/*
 * GeneralListener.java
 *
 * Created on September 20, 2007, 6:46 PM
 */
package jsp.listener;

import java.util.Date;
import java.util.Random;
import javax.servlet.ServletContextListener;
import javax.servlet.ServletContextEvent;
import javax.servlet.http.HttpSessionListener;
import javax.servlet.http.HttpSessionEvent;
import javax.servlet.ServletRequestListener;
import javax.servlet.ServletRequestEvent;
import javax.servlet.annotation.WebListener;
import jsp.beans.RandomBean;

/**
 * USED to put objects in the different scopes
 *
 * @author hajo
 */
@WebListener
public class InitListener implements ServletContextListener, HttpSessionListener,
        ServletRequestListener {

    Random r = new Random();

    @Override
    public void contextInitialized(ServletContextEvent evt) {
        // Date will live as long as application runs
        // Accessible in the jspx pages
        evt.getServletContext().setAttribute("date",
                new Date());
    }

    @Override
    public void sessionCreated(HttpSessionEvent evt) {
        // Store an object for this session to use in JSPX pages 
        evt.getSession().setAttribute("random", new RandomBean());
    }

    // ---- Unused ---
    @Override
    public void requestInitialized(ServletRequestEvent evt) {
    }

    @Override
    public void requestDestroyed(ServletRequestEvent evt) {
    }

    @Override
    public void contextDestroyed(ServletContextEvent sce) {
    }

    @Override
    public void sessionDestroyed(HttpSessionEvent se) {
    }
}
