/*
 * Servlet as target for filter
 */

package filter;


import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *  NOTE Watch web.xml for filter chaining (order of)
 * @author hajo
 * @version
 */
@WebServlet(name="FilteredServlet",  urlPatterns={"/filtered"})
public class FilteredServlet extends HttpServlet {
    
    
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
        
        System.out.println("*** Filtered Servlet ***");
       
        
        out.println("<html>");
        out.println("<head>");
        out.println("<title>FilteredServlet</title>");
        out.println("</head>");
        out.println("<body>");
        out.println("<h1>This is FilteredServlet</h1>");
        out.println("<h2>Watch output window to see filter hit's</h2>");
         out.println("<p> Got this in request from pre filter: " + 
                 request.getAttribute("key") + "</p>");
        out.println("</body>");
        out.println("</html>");
        out.close();
    }
    
    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }
    
    /** Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }
    
    /** Returns a short description of the servlet.
     */
    public String getServletInfo() {
        return "Short description";
    }
    // </editor-fold>
}
