
package filter;

import java.io.IOException;
import javax.servlet.*;
import javax.servlet.annotation.WebFilter;

/**
 * A filter for timing requests
 * @author  hajo
 */
@WebFilter("/*")  // Hit every request
public class TimerFilter implements Filter {
    
    public TimerFilter() {
    }
   
    @Override
    public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) 
            throws IOException, ServletException {
        
        long before = System.currentTimeMillis();
        chain.doFilter(request, response);
        long after = System.currentTimeMillis();
        
        System.out.println("Request time: " + (after-before));
    }
    
    @Override
    public void destroy() {}

    @Override
    public void init(FilterConfig filterConfig) throws ServletException {
    }
}
