/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package requestbased.ctrl;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.mail.MessagingException;
import javax.mail.NoSuchProviderException;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import requestbased.core.ShoppingCart;
import requestbased.service.MailService;

/**
 *
 * @author hajo
 */
@WebServlet(name = "FrontController", urlPatterns = {"/fc"})
public class FrontController extends HttpServlet {

    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

        String action = request.getParameter("action");
        String view = request.getParameter("view");

        // State changes and navigation
        if (action != null) {
            switch (action) {
                case "addItem":
                    ShoppingCart cart = (ShoppingCart) request.getSession().getAttribute("cart");
                    if (cart == null) {
                        cart = new ShoppingCart();
                        request.getSession().setAttribute("cart", cart);
                    }
                    String item = request.getParameter("item");
                    cart.addItem(item);
                    // Will cause the double submit!! 
                    request.getRequestDispatcher("WEB-INF/jsp/shop.jspx").forward(request, response);
                    break;
                case "sendOrder":
                    try {
                        cart = (ShoppingCart) request.getSession().getAttribute("cart");
                        request.getSession().invalidate();
                        if (cart != null && !cart.isEmpty()) {
                            MailService.newMailService().sendMail(cart.toString()); 
                            request.getRequestDispatcher("WEB-INF/jsp/thanks.jspx").forward(request, response);
                        }else {
                            request.getRequestDispatcher("index.jspx").forward(request, response);
                        }
                    } catch (NoSuchProviderException ex) {
                        Logger.getLogger(FrontController.class.getName()).log(Level.SEVERE, null, ex);
                    } catch (MessagingException ex) {
                        Logger.getLogger(FrontController.class.getName()).log(Level.SEVERE, null, ex);
                    }
                    break;
                default:
                    ;
            }
        }

        // Navigation
        if (view != null) {
            switch (view) {
                case "cart":
                    // Also possible to put something in requets for use in JSP
                    // request.setAttribute("key", someObject);
                    request.getRequestDispatcher("WEB-INF/jsp/viewCart.jspx").forward(request, response);
                    break;
                case "shop":
                    request.getRequestDispatcher("WEB-INF/jsp/shop.jspx").forward(request, response);
                    break;
                default:
                    ;
            }
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
