package edu.chl.hajo.chat.core;

import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author hajo
 */
public enum Chat {

    INSTANCE;
    private final IUserRegistry reg = new UserRegistry();
    private final ITopicList topics = new TopicList();

    private Chat() {
        Logger.getAnonymousLogger().log(Level.INFO, "Chat alive");
    }

    public void send(Message msg) {
        Logger.getAnonymousLogger().log(Level.INFO, "SENDING {0}", msg);
        List<User> recievers = msg.getRecievers();
        if (recievers != null) {
            for (User u : recievers) {
                if (u != null) {
                    u.recieve(msg);
                }
            }
        }
        Topic topic = msg.getTopic();
        if (topic != null) {
            for (User u : topic.getRegistred()) {
                if (u != null) {
                    u.recieve(msg);
                }
            }
        }
    }

    public IUserRegistry getReg() {
        return reg;
    }

    public ITopicList getTopics() {
        return topics;
    }

    public void setTestData() {
    }
}
