package edu.chl.hajo.chat.core;

import java.util.List;

/**
 *
 * @author hajo
 */
public class Message implements IEntity<String> {

    private final String id;
    private final User sender;
    private final Topic topic;
    private final List<User> recievers;
    private final String body;

    public Message( User sender, Topic topic, List<User> recievers, String body) {
        if( sender == null ){
            throw new IllegalArgumentException("No sender for message");
        }
        this.id =  sender.getId() + ":" + sender.nextSeq(); 
        this.sender = sender;
        this.topic = topic;
        this.recievers = recievers;
        this.body = body;
    }

    public String getBody() {
        return body;
    }

    public List<User> getRecievers() {
        return recievers;
    }

    public User getSender() {
        return sender;
    }

    public Topic getTopic() {
        return topic;
    }

    @Override
    public String toString() {
        return "Message{" + "sender=" + sender + ", topics=" + topic
                + ", recievers=" + recievers + ", body=" + body + '}';
    }

    public String getId() {
       return id;
    }
}
