package edu.chl.hajo.chat.core;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author hajo
 */
public class Topic implements IEntity<String> {

    private final String id;
    private final String description;
    private final List<User> registred = new ArrayList<User>();

    public Topic(String id, String description) {
        this.id = id;
        this.description = description;
    }

    @Override
    public String getId() {
        return id;
    }

    public String getDescription() {
        return description;
    }

    @Override
    public String toString() {
        return "Topic{" + id + '}';
    }

    public void add(User user) {
        registred.add(user);
    }

    public void remove(User user) {
        registred.remove(user);
    }

    public List<User> getRegistred() {
        return registred;
    }
}
