package edu.chl.hajo.chat.core;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author hajo
 */
public class User implements IEntity<String> { 

    private final String id; // Unique
    private String passwd;
    private List<User> followers = new ArrayList<>();
    private final transient Inbox inbox = new Inbox();
    // private final transient Outbox outbox = new Outbox();
    private long seq;
  

    public User(String id, String passwd) {
        this.id = id;
        this.passwd = passwd;
    }
  
    public long nextSeq(){
        return seq++;
    }

    public String getPasswd() {
        return passwd;
    }

    public void setPasswd(String passwd) {
        this.passwd = passwd;
    }

    @Override
    public String getId() {
        return id;
    }

    public List<User> getFollowers() {
        return followers;
    }

    public void addFollower(User follower) {
        followers.add(follower);
    }

    public void removeFollower(User follower) {
        followers.remove(follower);
    }

    @Override
    public String toString() {
        return "User{" + id + '}';
    }

    public List<Message> getRecievedMessages(){
        return inbox.getAll();
    }
    
    void recieve(Message msg) {
       inbox.add(msg);
    }
}
