package edu.chl.hajo.push;

import java.io.Serializable;
import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;
import javax.servlet.http.HttpSession;
import org.icefaces.application.PushRenderer;

/*
 *  Very simple use of ICEFaces push
 * 
 *  NOTE: Dependency of icepush-n.n.n.jar
 * 
 *  RUN ON GLASSFISH
 * 
 */
@Named("colorBean")
@RequestScoped
public class ColorBean implements Serializable {

    private static final String PUSH_GROUP = "colorPage";
    @Inject
    private MessageBean messageBean;
    private String color = "black";
    private String sessionId;

    @PostConstruct
    public void postConstruct(){
        // Add a session and all associated pages (views) to a group
        // Will use FacesContext internally, so it must be
        // accesible here
        PushRenderer.addCurrentSession(PUSH_GROUP);

        // This is just jused as demo, no meaing in push environment
        FacesContext fcontext = FacesContext.getCurrentInstance();
        HttpSession session = (HttpSession) fcontext.getExternalContext().getSession(false);
        sessionId = session.getId();
    }

    public void setMessageBean(MessageBean messageBean) {
        this.messageBean = messageBean;
    }

    public String getColor() {
        return color;
    }

    public void setColor(String color) {
        this.color = color;
    }

    public String push() {
        messageBean.addToList(sessionId, color);
        // Push to all in group
        PushRenderer.render(PUSH_GROUP);

        return null; // Navigation stay on same page
    }
}
