
package edu.chl.hajo.jeesec.db;

import java.util.List;
import javax.ejb.Local;

/**
 * A Data Access Object (DAO) A slight modification of 
 * the model interface IEntityContainer, 
 * implemented by the AbstractDAO
 * @author hajo
 */
@Local
public interface IDAO<T, K> {

    public void add(T t);

    public void remove(K id);

    public void update(T t);

    public T find(K id);

    public List<T> getAll();

    public List<T> getRange(int maxResults, int firstResult);

    public int getCount();
}
