/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package edu.chl.hajo.jeesec.listener;

import edu.chl.hajo.jeesec.core.AppUser;
import edu.chl.hajo.jeesec.core.AppUserRegistry;
import edu.chl.hajo.jeesec.core.Customer;
import edu.chl.hajo.jeesec.core.CustomerRegistry;
import edu.chl.hajo.jeesec.security.SubjectGroup;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;
import javax.servlet.annotation.WebListener;
import javax.sql.DataSource;

/**
 * This is just to put some data into the database
 *
 * @author hajo
 */
@WebListener()
public class SecurityListener implements ServletContextListener {

    CustomerRegistry customerRegistry = lookupCustomerRegistryBean();
    AppUserRegistry appUserRegistry = lookupAppUserRegistryBean();

    @Override
    public void contextInitialized(ServletContextEvent sce) {
        // Dummy data
        Customer t = new Customer("olle", "olle", "fname", 99);
        AppUser u = new AppUser("admin", "admin", "pelle", "eco", SubjectGroup.ADMIN);
        try {
            // Will get exception if users aready there
            customerRegistry.add(t);
            appUserRegistry.add(u);
        } catch (Exception e) {
            Logger.getAnonymousLogger().log(Level.INFO, "Couldn't add admin and olle");
        }
    }

    @Override
    public void contextDestroyed(ServletContextEvent sce) {
        // throw new UnsupportedOperationException("Not supported yet.");
    }

    private AppUserRegistry lookupAppUserRegistryBean() {
        try {
            Context c = new InitialContext();
            return (AppUserRegistry) c.lookup("java:global/edu.chl.hajo_jee_security_war_1.0-SNAPSHOT/AppUserRegistry!edu.chl.hajo.jeesec.core.AppUserRegistry");
        } catch (NamingException ne) {
            Logger.getLogger(getClass().getName()).log(Level.SEVERE, "exception caught", ne);
            throw new RuntimeException(ne);
        }
    }

    private CustomerRegistry lookupCustomerRegistryBean() {
        try {
            Context c = new InitialContext();
            return (CustomerRegistry) c.lookup("java:global/edu.chl.hajo_jee_security_war_1.0-SNAPSHOT/CustomerRegistry!edu.chl.hajo.jeesec.core.CustomerRegistry");
        } catch (NamingException ne) {
            Logger.getLogger(getClass().getName()).log(Level.SEVERE, "exception caught", ne);
            throw new RuntimeException(ne);
        }
    }
}
