package edu.chl.hajo.jpaem.core;

import java.io.Serializable;
import java.util.List;
import javax.persistence.*;

/**
 *
 * @author hajo
 */
@Entity
public class Person implements Serializable {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long pnumb;
    private String fname;
    private int age;
    @OneToMany(mappedBy = "owner")
    private List<Car> cars;

    // Must have for JAXB
    public Person() {
    }

    public Person(String fname, int age) {
        this.fname = fname;
        this.age = age;
    }
    
    public List<Car> getCars() {
        return cars;
    }

    public void setCars(List<Car> cars) {
        this.cars = cars;
    }
    
    public void addCar( Car car ){
        this.cars.add(car);
    }

    public String getFname() {
        return fname;
    }

    public void setFname(String fname) {
        this.fname = fname;
    }

    public Long getPnumb() {
        return pnumb;
    }

    public void setPnumb(Long pnumb) {
        this.pnumb = pnumb;
    }

    public int getAge() {
        return age;
    }

    public void setAge(int age) {
        this.age = age;
    }

    // This is special style of equals
    @Override
    public final boolean equals(Object obj) {
        if (obj == this) {
            return true;
        }
        if (!(obj instanceof Person)) { // Will handle null
            return false;
        }
        final Person other = (Person) obj;
        // Tricky, id is Long reference
        return other.pnumb.equals(this.pnumb);
    }

    @Override
    public final int hashCode() {
        int hash = 7;
        hash = 73 * hash + (this.pnumb != null ? this.pnumb.hashCode() : 0);
        return hash;
    }
}
