package edu.chl.adamw.rtw.model;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.UUID;
import java.util.concurrent.ConcurrentHashMap;

public class ChatRoom {
	public static int DEFAULT_MAX_NUMBER_OF_USERS = 10;

	private int maxUsers = DEFAULT_MAX_NUMBER_OF_USERS;
	private List<Message> messages = Collections.synchronizedList(new ArrayList()); 
	private String name;
	private Map<UUID, User> users = new ConcurrentHashMap<>();

	public ChatRoom(String name) {
		this.name = name;
	}

	public int getMaxUsers() {
		return maxUsers;
	}

	public void setMaxUsers(int maxUsers) {
		this.maxUsers = maxUsers;
	}

	public List<Message> getMessages() {
		return messages;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Map<UUID, User> getUsers() {
		return users;
	}

	public List<User> getUsersList() {
		return new ArrayList<>(users.values());
	}
}
